<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Workshop Terraform</title>

		<link rel="stylesheet" href="css/reset.css">
    <link rel="stylesheet" href="css/reveal.css">
    <link rel="stylesheet" href="css/custom.css">
    <link rel="stylesheet" href="css/theme/white.css">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
    </script>
	</head>
	<body>
		<div class="reveal">
			<div class="slides">
        
        <!-- Introduction -->
        <section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <h1>Workshop Terraform</h1>
            <img height="200px" data-src="../img/terraform-logo.png">
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <img data-src="../img/Logo-SC2019_web.png" alt="SophiaConf 2019">
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <h2>Formateur</h2>
            <div class="container">
              <div class="col">
                <img height="265px" data-src="../img/Thomas_Perelle.jpg">
              </div>
              <div class="col left" style="flex: 2;">
                <p>Thomas Perelle</p>
                <p>Consultant DevOps & Cloud<br>
                Chez <a href="https://treeptik.fr">TREEPTIK</a></p>
                <p>
                  <a href="https://www.linkedin.com/in/thomasperelle/"><img height="40px" data-src="../img/linkedin-logo.png"></a>
                  <a href="https://twitter.com/tperelle?lang=fr"><img height="40px" data-src="../img/twitter-logo.png"></a>
                </p>
              </div>
            </div>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <h2>Plan</h2>
            <ul>
              <li>Présentation de Terraform</li>
              <li>Mise en oeuvre</li>
              <li>Concepts de base</li>
              <li>Faire du code réutilisable</li>
              <li>Exercices</li>
            </ul>
          </section>

        </section>
        <!-- End Introduction -->

        <!-- Présentation -->
        <section>
          
          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <h1>Présentation de Terraform</h1>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <ul>
              <li><a href="https://www.terraform.io">Terraform</a> a été crée en 2014 par <a href="https://www.hashicorp.com">HashiCorp</a></li>
              <li>C'est un outil Open Source</li>
              <li>Ecrit en <a href="https://golang.org">Go</a></li>
              <li>Une communauté de <a href="https://github.com/hashicorp/terraform">plus de 1000 contributeurs</a></li>
              <li>Une architecture basée sur des plugins</li>
              <li>Sans agent</li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <p>Terraform gère l'ensemble du cycle de vie d'une infrastructure :</p>
            <ul>
              <li>Création</li>
              <li>Modification</li>
              <li>Suppression</li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <p>Plus précisément :</p>
            <ul>
              <li>Il assure la création et la cohérence d’infrastructure</li>
              <li>Il permet d’appliquer des modifications incrémentales</li>
              <li>On peut détruire des ressources si besoin</li>
              <li>On peut prévisualiser les modifications avant de les appliquer</li>
            </ul>
            <p>C'est un outil tout à fait adapté pour :
            <ul>
              <li>Les chaînes <mark>CI/CD</mark></li>
              <li>Les démarches d'<mark>infrastructure immutables</mark></li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <p>Les fichiers source, ou template de configuration sont écrit en <b>HCL</b> (HashiCorp Configuration Language) :</p> 
            <ul>
              <li>Langage plutôt simple et intuitif</li>
              <li>Extension des fichiers <b>.tf</b></li>
            </ul>
            <p>Terraform scan automatiquement tous les fichiers *.tf du répertoire courant.</p>
            <p>A minima, un projet Terraform est constitué de :</p>
            <pre><code class="hljs">
  terraform {}
            </code></pre>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <h3>Attention :</h3>
            <p>Contrairement à ce que l'on peut lire, <mark>Terraform n'est pas agnostique</mark>.</p>
            <p>Il s'appuie sur différents objets <b>providers</b> pour intéragir avec les différents <b>fournisseurs</b> d'infrastructure.</p>
            <p>Néanmoins :</p>
            <ul>
              <li>Pas de notion de vendor locking</li>
              <li>On capitalise sur un outil unique pour des infrastructures hybrides</li>
              <li>On peut migrer facilement d'un fournisseur à l'autre</li>
            </ul>
            
          </section>

        </section>
        <!-- End Présentation -->

        <!-- Mise en oeuvre -->
        <section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <h1>Mise en oeuvre</h1>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <h2>Installation</h2>
            <p>L'installation de Terraform est très simple :</p>
            <ul>
              <li>Télécharger l'archive zip correspondante à votre OS sur <a href="https://www.terraform.io/downloads.html">https://www.terraform.io/downloads.html</a></li>
              <li>Décompresser l'archive</li>
            </ul>
            <p>Terraform fonctionne via un binaire autoportant <mark>terraform</mark>, les autres fichiers de l'archive peuvent être supprimés.</p>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px"data-background-position="0 0" >
            <h2>Installation</h2>
            <p>Le répertoire d'installation devra être présent dans le <mark>PATH</mark>.</p>
            <p>Utiliser :</p>
            <ul>
              <li><b>terraform version</b> pour obtenir la version installée</li>
              <li><b>terraform</b> pour obtenir la page d'aide</li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Terraform CLI</h2>
            <p>Le binaire terraform est une CLI :</p>
            <pre><code class="hljs Bash">
  $ terraform
  Usage: terraform [--version] [--help] &lt;command&gt; [args]
            </code></pre>
            <p>Principales commandes pour gérer le cycle de vie d'une infrastructure :</p>
            <ul>
              <li><b>init: </b>Initialise un nouveau projet ou un projet existant</li>
              <li><b>validate: </b>Vérifie la syntaxe des fichiers source</li>
              <li><b>plan: </b>Affiche le plan d'exécution</li>
              <li><b>apply: </b>Crée ou modifie l'infrastructure</li>
              <li><b>destroy: </b>Détruit toutes les ressources</li>
            </ul>
          </section>

        </section>
        <!-- End Mise en oeuvre -->
          
        <!-- Concepts de base -->
        <section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h1>Concepts de base</h1>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Providers</h2>
            <p>Un provider est responsable du cycle de vie d’une ressource : sa création, sa lecture, sa mise à jour et sa suppression.</p>
            <p>De nombreux providers sont proposés, par exemple :</p>
            <ul>
              <li>AWS</li>
              <li>Azure</li>
              <li>Digital Ocean</li>
              <li>Google Cloud Platform</li>
              <li>OVH</li>
              <li>Nutanix</li>
            </ul>
            <p>La list complète des providers est <a href="https://www.terraform.io/docs/providers/index.html">sur le site de Terraform.</a>
            Il est aussi possible de développer son propre plugin en Go.</p>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Providers</h2>
            <p>Voici la déclaration du provider Digital Ocean dans Terraform :</p>
            <pre><code  class="hljs">
  provider "digitalocean" {
    version = ">= 1.4.0"
  }
            </code></pre>
            <p>Une bonne pratique consiste à mettre les <mark>credentials</mark> nécessaires au provider en variable d'environnement pour les sortir du code :</p>
            <pre><code class="hljs Bash">
  $ export DIGITALOCEAN_TOKEN=YOUR_DIGITALOCEAN_TOKEN
  $ export SPACES_ACCESS_KEY_ID=YOUR_SPACES_ACCESS_KEY_ID
  $ export SPACES_SECRET_ACCESS_KEY=YOUR_SPACES_SECRET_ACCESS_KEY
            </code></pre>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Ressources</h2>
            <p>La notion de ressource est l'élément le plus important dans le langage Terraform.</p>
            <p>Chaque bloc <mark>resource</mark> décrit un objet d'infrastructure :</p>
            <ul>
              <li>Réseau virtuel</li>
              <li>Instance</li>
              <li>Disque</li>
              <li>Domaine ou entrée DNS</li>
              <li>Etc.</li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Ressources</h2>
            <p>Chaque ressource possède un <b>type</b>, un <b>nom</b> local et des <b>propriétés</b> :</p>
            <pre><code class="hljs">
  # Create a new Web Droplet in the nyc2 region
  resource "digitalocean_droplet" "web" {
    image  = "ubuntu-18-04-x64"
    name   = "web-1"
    region = "nyc2"
    size   = "s-1vcpu-1gb"
  }
            </code></pre>
            <ul>
              <li>Le type est dépendant du provider utilisé</li>
              <li>Le couple type+nom sert d'identifiant de la ressource et doit être unique</li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Variables</h2>
            <p>Pour avoir du code propre et dynamique, il faut utiliser les variables.</p> 
            <p>Elles doivent être définies dans un fichier <mark>variables.tf</mark> :</p>
            <pre><code  class="hljs json">
  variable "DO_REGION" {
    default = "fra1"
  }

  variable "VM_NUMBER" {
    default = 1
  }
  
  variable "VM_IMAGE" {
    default = "ubuntu-18-04-x64"
  }
  
  variable "VM_SIZE" {
    default = "s-1vcpu-1gb"
  }

  variable "VM_TAGS" {
    default = ["training-terraform", "terraform"]
  }
            </code></pre>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Variables</h2>
            <p>Les différents types supportés par Terraform :</p>
            <ul>
              <li><b>String :</b> "hello"</li>
              <li><b>Number :</b> 15 ou 6.283185</li>
              <li><b>Bool :</b> true ou false</li>
              <li><b>List :</b> ["us-west-1a", "us-west-1c"]</li>
              <li><b>Map :</b> {name = "Mabel", age = 52}</li>
              <li><b>Null</b></li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Variables</h2>
            <p>On peut ensuite les utiliser dans les ressources :</p>
            <pre><code  class="hljs">
  # Create Droplet
  resource "digitalocean_droplet" "vm" {
    count    = "${var.VM_NUMBER}"
    name     = "vm-${count.index}"
    image    = "${var.VM_IMAGE}"
    region   = "${var.DO_REGION}"
    size     = "${var.VM_SIZE}"
    tags     = "${var.VM_TAGS}"
  }
            </code></pre>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Variables</h2>
            <p>On peut surcharger le fichier <em>variables.tf</em> par un fichier <mark>terraform.tfvars</mark></p>
            <pre><code  class="hljs">
  VM_NUMBER = 3
  VM_IMAGE  = "ubuntu-18-04-x64"
  VM_SIZE   = "s-1vcpu-1gb" 
            </code></pre>
            <p>En général on ajoute ce fichier dans le <em>.gitignore</em> pour ne pas le versionner.</p>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>State</h2>
            <p>Un fichier d'état ou <b>state</b> est une image de votre infrastructure à un instant T :</p>
            <ul>
              <li>Terraform stocke l'état de l'infrastructure dans un fichier</li>
              <li>Par défaut l'état est stocké en local dans un fichier <mark>terraform.tfstate</mark></li>
              <li>Le state est modifié à chaque exécution des commandes apply ou destroy</li>
              <li>Il est possible et recommandé de stocker ce fichier d'état dans le cloud</li>
              <li><u>Attention :</u> ce fichier state peut contenir des informations sensibles</li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>State</h2>
            <p>Pour stocker le state dans le cloud, il faut configurer un <b>backend</b> :</p>
            <pre><code  class="hljs">
# Configure Terraform
terraform {
  required_version = ">= 0.12.0"

  # Backend on AWS
  backend "s3" {
    # Bucket name created before
    bucket               = "terraform-backend"
    key                  = "terraform.tfstate"
    dynamodb_table       = "terraform-state-lock-dynamo"
  }
}
            </code></pre>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>State</h2>
            <p>L'utilisation d'un backend permet de :</p>
            <ul>
              <li>Travailler en équipes</li>
              <li>Ne pas conserver d'informations sensibles en local</li>
              <li>Mettre en place une politique de sauvegarde</li>
              <li>Limiter le risque de suppression par inadvertance</li>
            </ul>
          </section>

        </section>
        <!-- End Concepts de base -->

        <!-- Faire du code réutilisable -->
        <section>
          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h1>Faire du code réutilisable</h1>
          </section>

          <section>
            <h2>Modules</h2>
            <p>Les modules sont utilisés pour :</p>
            <ul>
              <li>Créer des composants réutilisables</li>
              <li>Améliorer l’organisation du code et sa maintenance</li>
              <li>Traiter certains éléments d’infrastructure comme des boîtes noires</li>
            </ul>
            <p>C’est un groupe de ressources qui prennent en entrée des paramètres et retournent en sortie des outputs.</p>
            <p>Les sources des modules sont en générale placées dans l'arborescence <mark>./modules/MODULE_NAME/</mark>.</p>
          </section>

          <section>
            <h2>Modules</h2>
            <p>Pour utiliser un module dans votre projet il faut définir le module avec l'emplacement de ses sources et passer les variables attendues :</p>
            <pre><code class="hljs">
  module "lambda" {
    source            = "./modules/lambda/"
    bucket            = "${var.aws_s3_bucket}"
    titi              = "${var.aws_s3_bucket_titi_key}"
    tutu              = "${var.aws_s3_bucket_tutu_key}"
  }
            </code></pre>
            <p>La directory <mark>./modules/lambda/</mark> contient l'ensemble des sources du module.</p>
          </section>

          <section>
            <h2>Modules</h2>
            <p>Les sources du module peuvent provenir de différents fournisseurs :</p>
            <ul>
              <li>Filesystem local</li>
              <li>Registry Terraform</li>
              <li>Github, Bitbucket ou autre repository Git ou Mercurial</li>
              <li>Url Http</li>
              <li>Bucket S3</li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Output</h2>
            <p>Les output sont utilisés pour :</p>
            <ul>
              <li>Afficher des valeurs à l'écran</li>
              <li>Faire passer des valeurs d’un module à un autre</li>
              <li>Stocker des variables calculées dans le state</li>
            </ul>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Output</h2>
            <p>Voici la déclaration d'un output :</p>
            <pre><code  class="hljs">
  output "authorizer_uri" {
    value = "${aws_lambda_function.lambda_toto.invoke_arn}"
  }
            </code></pre>
            <p>Les valeurs retournées peuvent ensuite être utilisées dans les ressources :</p>
            <pre><code  class="hljs">
  resource "aws_api_gateway_authorizer" "custom_authorizer" {
    name                             = "CustomAuthorizer"
    rest_api_id                      = "${aws_api_gateway_rest_api.toto_api.id}"
    authorizer_uri                   = "${module.lambda.authorizer_uri}"
    identity_validation_expression   = "Bearer .*"
    authorizer_result_ttl_in_seconds = "30"
  }
            </code></pre>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Templates</h2>
            <p>Terraform possède un provider <mark>Template</mark> qui permet de mettre en forme du contenu pour d'autres ressources.</p>
            <p>Ce plugin, couplé au plugin <mark>Local</mark> peut permettre de générer des fichiers tel que :</p>
            <ul>
              <li>Un inventaire Ansible</li>
              <li>Un fichier SSH Config</li>
              <li>Ou tout autre fichier nécessitant des informations provenant de l'infrastructure</li>
            </ul>
          </section>
        </section>
        <!-- End Faire du code réutilisable -->
        
        <!-- Exercises -->
        <section>
          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h1>Exercices</h1>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Environnement</h2>
            <p class="center"><img data-src="../img/Terraform_training_environment.png"></p>
          </section>

          <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
            <h2>Exercices</h2>
            <p>Le support d'exercice est disponible sur :<br>
              <a href="https://gitlab.com/treeptik/public/events/sophiaconf2019-terraform-workshop/blob/master/exercises/README.md">https://gitlab.com/treeptik/public/events/sophiaconf2019-terraform-workshop</a></p>
            <ul>
              <li>Exercice1 : Initialisation d'un projet</li>
              <li>Exercice2 : Création d'une VM</li>
              <li>Exercice3 : Utilisation des variables</li>
              <li>Exercice4 : Modification de l'infrastructure</li>
              <li>Exercice5 : Générer un inventaire Ansible</li>
              <li>Exercice6 : Destruction de l'infrastructure</li>
            </ul>
          </section>
        </section>
        <!-- End Exercises -->

        <!-- Questions -->
        <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
          <p class="center"><img height="400px" data-src="../img/any-questions.jpg"></p>
        </section>
        <!-- End Questions -->

        <!-- Merci -->
        <section data-background="../img/Logo-Treeptik-noir.png" data-background-opacity="1" data-background-size="400px" data-background-position="0 0">
          <p class="center"><img height="400px" data-src="../img/thanks.jpg"></p>
        </section>
        <!-- End Merci -->
			</div>
		</div>

		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
        slideNumber: true,
        progress: true,

				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
          { src: 'plugin/notes/notes.js', async: true },
          { src: 'plugin/search/search.js', async: true },
					{ src: 'plugin/zoom-js/zoom.js', async: true },
					{ src: 'plugin/highlight/highlight.js', async: true }
				]
			});
		</script>
	</body>
</html>
